(use magic-pipes)
(use args)
(use ports)
(use chicken-syntax)
(use sxml-serializer)

(receive (options operands before-exprs after-exprs usage)
         (parse-mp-args (command-line-arguments) '()
                        ""
                        "Read s-expressions from standard input, and convert them to XML on standard output.")
         (unless (= (length operands) 0)
                 (usage))

         (let* ((ec (make-eval-context before-exprs '() after-exprs)))
           (for-each-input-datum
            (lambda (sexpr)
              (serialize-sxml sexpr output: (current-output-port))
              (newline)))
           (without-input-port
            (eval-context-end-closure ec))))
